
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CONTENT_SELECTOR_H
#define PG_CONTENT_SELECTOR_H

#include "xstd/Array.h"
#include "csm/ContentTypeIdx.h"

class ObjId;
class RndDistr;
class ContentCfg;
class ContentSym;
class ServerSym;

// selects content configuration based on object identifier
class ContentSel: public ContentTypeIdx {
	public:
		ContentSel();
		~ContentSel();

		void configure(const ServerSym *cfg);

		ContentCfg *getDir(const ObjId &oid);
		
	protected:
		void computeDaProbs(const Array<ContentCfg*> &ccfgs, const Array<ContentSym*> &dasyms, const Array<double> &cprobs, Array<double> &daprobs);

	protected:
		Array<ContentCfg*> theDirectAccess;  // directly accessible content
		RndDistr *theDirAccSel;              // selector for the above
};

#endif
