
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_DNS_MESSAGE_H
#define PG_DNS_MESSAGE_H

#include "xstd/NetAddr.h"

// common type for all DNS messages
class DnsMsg {
	public:
		typedef enum { rcodeMask = 0x07, rcodeFmt = 1, rcodeSrvFail, rcodeNoName, rcodeNoSupp, rcodeRefused } RCodes;
		typedef enum { flagQuery  = (0 << 15), flagResp = (1 << 15), flagAQuery = (0 << 11) } Flags;
		typedef enum { typeA = 1 } Types;
		typedef enum { classIn = 1 } Classes;

		enum { LabelLenMax = 63 };

		typedef unsigned short Field;

	public:
		static Field LastId() { return TheLastId; }
		static Field NextId();

	private:
		static Field TheLastId;

	public:
		DnsMsg();

		void id(int anId) { theId = anId; }
		void queryAddr(const NetAddr &addr) { theQueryAddr = addr; }

		const NetAddr &queryAddr() const { return theQueryAddr; }
		Field id() const { return theId; }

	protected:
		NetAddr theQueryAddr;
		Field theId;
};

#endif
