
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglRec.h"
#include "pgl/DnsResolverSym.h"


DnsResolverSym::DnsResolverSym(): RecSym("DnsResolver", new PglRec) {
	theRec->bAdd("addr[]", "servers", 0);
	theRec->bAdd("time", "timeout", 0);
}

DnsResolverSym::DnsResolverSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool DnsResolverSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "DnsResolver";
}

SynSym *DnsResolverSym::dupe(const String &type) const {
	if (isA(type))
		return new DnsResolverSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}

Time DnsResolverSym::timeout() const {
	return getTime("timeout");
}

bool DnsResolverSym::servers(Array<NetAddr*> &srvs) const {
	return getNetAddrs("servers", srvs);
}
