
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_DISTRIBUTION_SYMBOL_H
#define PGL_DISTRIBUTION_SYMBOL_H

#include "pgl/PglExprSym.h"

class String;
class RndDistr;
class QualifSym;

// a distribution with an optional qualifier

class DistrSym: public ExpressionSym {
	public:
		static void IntArgPrinter(ostream &os, double arg, int);
		static void SizeArgPrinter(ostream &os, double arg, int);
		static void TimeArgPrinter(ostream &os, double arg, int);

	public:
		DistrSym(const String &aType, RndDistr *aVal);
		virtual ~DistrSym();

		virtual bool isA(const String &type) const;

		RndDistr *val() const { return theVal; }

		void qualifier(const QualifSym *aQual, const String &anOp);
		QualifSym *qualifier() const { return theQual; }
		const String &qfOp() const { return theQfOp; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

	protected:
		mutable RndDistr *theVal;
		QualifSym *theQual; // qualifier
		String theQfOp;     // qualifier operator
};

#endif
