
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_ROBOT_SYMBOL_H
#define PG_ROBOT_SYMBOL_H

#include "xstd/Array.h"
#include "pgl/AgentSym.h"

class String;
class RndDistr;
class SessionSym;
class DnsResolverSym;


// server side configuration
class RobotSym: public AgentSym {
	public:
		RobotSym();
		RobotSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		bool reqInterArrival(RndDistr *&iad) const;
		bool publicRatio(double &ratio) const;
		bool recurRatio(double &ratio) const;
		bool embedRecurRatio(double &ratio) const;
		bool uniqueUrls(bool &set) const;
		bool openConnLimit(int &lmt) const;
		bool waitXactLimit(int &lmt) const;
		bool minimizeNewConn(double &prob) const;
		SessionSym *session() const;
		bool icpPort(int &port) const;
		NetAddr peerHttp() const;
		NetAddr peerIcp() const;
		DnsResolverSym *dnsResolver() const;
		bool privCache(int &capacity) const;
		bool proxies(Array<NetAddr*> &addrs) const;
		bool origins(Array<NetAddr*> &addrs) const;
		bool origins(Array<NetAddr*> &addrs, RndDistr *&sel) const;
		bool usernames(Array<String*> &names) const;
		RndDistr *reqMethods(const StrIdentifier &reqMethodNames) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
		virtual const char *msgTypesField() const;
		bool reqRate(double &rate) const;
};

#endif
