
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/gadgets.h"
#include "base/ILog.h"
#include "base/OLog.h"
#include "runtime/StatPhase.h"
#include "runtime/Goal.h"

#include "pgl/GoalSym.h"


Goal::Goal() {
}

void Goal::configure(const GoalSym *cfg) {
	Assert(cfg);
	theDuration = cfg->duration();
	cfg->xactCount(theXactCnt);
	cfg->fillSize(theFillSz);
	cfg->errs(theErrs.theRatio, theErrs.theCount);
}

// XXX: magic constant in "theXactCnt >= 1000"
bool Goal::reached(const GoalSubj &s) const {
	return // meeting one sub-goal is enough!
		(theDuration >= 0 && theDuration <= s.duration()) ||
		(theXactCnt >= 0 && theXactCnt <= s.xactCnt()) ||
		(theFillSz >= 0 && theFillSz <= s.fillSz()) ||
		(theErrs.count() >= 0 && theErrs.count() <= s.xactErrCnt()) ||
		(s.xactCnt() >= 1000 && theErrs.ratio() >= 0 && theErrs.ratio() <= s.xactErrRatio())
		;
}


/* GoalSubj */

GoalSubj::~GoalSubj() {
}

double GoalSubj::xactErrRatio() const {
	return Ratio(xactErrCnt(), xactCnt());
}
