
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include <limits.h>
#include <stdlib.h>

#include "xstd/Rnd.h"
#include "base/RndPermut.h"
#include "xstd/gadgets.h"


static
int uncorr(int n) {
	//int exp;
	//const double x = INT_MAX * (2*frexp(::sin((double)n), &exp) - 1);
	const double x = INT_MAX * ::sin(n*(double)n);
	const double y = fabs(x);
	return (int)Min(y, (double)INT_MAX);
}

int main(int argc, char *argv[]) {
	int sampleCount = -1;
	if (argc != 2 || !isInt(argv[1], sampleCount)) {
		cerr << "usage: " << argv[0] << " <number_of_samples>" << endl;
		return 0;
	}

	RndGen rngCont;
	RndGen rngSeeded;
	RndGen rngPermut;

	for (int i = 1; i <= sampleCount; ++i) {
		rngSeeded.seed(i);
		rngPermut.seed(LclPermut(i));
		cout
			<< ' ' << rngCont.ltrial()
			<< ' ' << rngSeeded.ltrial()
			<< ' ' << rngPermut.ltrial()
			<< ' ' << uncorr(i)
			<< endl;
	}

	return 0;
}
