
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/String.h"
#include "xml/XmlDoc.h"

XmlDoc::XmlDoc(): theRoot(0) {
}

XmlDoc::~XmlDoc() {
	delete theRoot;
}

void XmlDoc::root(const XmlNode &aRoot) {
	Assert(!theRoot);
	theRoot = aRoot.clone();
}

ostream &XmlDoc::print(ostream &os, const String &pfx) const {
	os << pfx << "<?xml version='1.0'?>" << endl;
	if (theRoot)
		theRoot->print(os, pfx);
	return os;
}
