
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef XPARSER_LEXER_H
#define XPARSER_LEXER_H

#include "xparser/LexToken.h"

// generic lexer
class Lexer {
	public:
		virtual ~Lexer() {}

		const LexToken &nextToken() { return(theToken = scan()); }
		const LexToken &token() const { return theToken; }

		int symbol() const { return token().id(); };
		const String &spelling() const { return token().spell(); }

	protected:
		virtual LexToken scan() = 0;

	protected:
		LexToken theToken;
};

#endif
